import java.io.*;
import org.xml.sax.*;
import org.xml.sax.helpers.DefaultHandler;
import javax.xml.parsers.SAXParserFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParser.*;
import java.lang.String;

public class sdsHandler extends DefaultHandler {

  FileWriter outfile;
  File inputFile;
  SAXParserFactory factory;
  SAXParser saxParser;
  static private Writer  out;

  //////////////////////////

  public sdsHandler(){
    super();
    factory = SAXParserFactory.newInstance();
    try {
        out = new OutputStreamWriter(System.out, "UTF8");
        saxParser = factory.newSAXParser();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  public void process(String inFile, String outputFile){
    try {
      inputFile = new File(inFile);
      outfile = new FileWriter(new File(outputFile));
      saxParser.parse(inputFile, this);
      outfile.close();
    }
    catch (Throwable t) {
      t.printStackTrace();
    }
  }

    //===========================================================
    // SAX DocumentHandler methods
    //===========================================================
    public void startDocument() throws SAXException {
        emit("<?xml version='1.0' encoding='UTF-8'?>");
        nl();
    }

    public void endDocument() throws SAXException {
        try {
            nl();
            out.flush();
        } catch (IOException e) {
            throw new SAXException("I/O error", e);
        }
    }
    public void startElement(String namespaceURI,
                             String lName, // local name
                             String qName, // qualified name
                             Attributes attrs) throws SAXException {
        String eName = lName; // element name
        if ("".equals(eName)) eName = qName; // namespaceAware = false
        emit("<"+eName);
        if (attrs != null) {
            for (int i = 0; i < attrs.getLength(); i++) {
                String aName = attrs.getLocalName(i); // Attr name
                if ("".equals(aName)) aName = attrs.getQName(i);
                emit(" ");
                emit(aName+"=\""+attrs.getValue(i)+"\"");
            }
        }
        emit(">");
    }
    public void endElement(String namespaceURI,
                           String sName, // simple name
                           String qName  // qualified name
                          ) throws SAXException {
        emit("</"+qName+">");
    }

    public void characters(char buf[], int offset, int len) throws SAXException{
        String s = new String(buf, offset, len);
        emit(s);
    }

    //===========================================================
    // Utility Methods ...
    //===========================================================
    // Wrap I/O exceptions in SAX exceptions, to
    // suit handler signature requirements
    private void emit(String s) throws SAXException {
        try {
            out.write(s);
            out.flush();
            outfile.write(s);
        } catch (IOException e) {
            throw new SAXException("I/O error", e);
        }
    }

    // Start a new line
    private void nl() throws SAXException {
        String lineEnd =  System.getProperty("line.separator");
        try {
            out.write(lineEnd);
            outfile.write(lineEnd);
        } catch (IOException e) {
            throw new SAXException("I/O error", e);
        }
    }
}